<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xs="http://www.w3.org/2001/XMLSchema"
                xmlns:pkg="http://expath.org/ns/pkg"
                xmlns:pp="http://expath.org/ns/packager"
                xmlns:file="http://expath.org/ns/file"
                xmlns:zip="http://expath.org/ns/zip"
                exclude-result-prefixes="#all"
                version="2.0">

   <xsl:import href="project-lib.xsl"/>

   <xsl:import href="http://expath.org/ns/file.xsl"/>
   <xsl:import href="http://expath.org/ns/zip.xsl"/>

   <pkg:import-uri>http://expath.org/ns/packager/release-project.xsl</pkg:import-uri>

   <xsl:output method="text"/>

   <xsl:template match="/">
      <xsl:message>
         <xsl:text>Releasing project </xsl:text>
         <xsl:value-of select="$pp:project"/>
      </xsl:message>
      <xsl:variable name="zip" as="element(zip:file)">
         <zip:file href="{ $release }">
            <zip:dir name="{ $prj-name }">
               <!-- the package -->
               <zip:entry src="{ $xar }"/>
               <!-- the README file if any -->
               <xsl:if test="file:old-list($build)/file:file[@name eq 'README']">
                  <zip:entry src="{ resolve-uri('README', $build) }"/>
               </xsl:if>
               <!-- a copy of src/ -->
               <xsl:sequence select="pp:zip-directory($src)"/>
               <!-- a copy of sample/ -->
               <xsl:sequence select="pp:zip-directory($sample)"/>
            </zip:dir>
         </zip:file>
      </xsl:variable>
      <xsl:variable name="final-zip" as="element(zip:file)">
         <xsl:apply-templates select="$zip" mode="pp:modify-release"/>
      </xsl:variable>
      <xsl:sequence select="zip:zip-file($final-zip)"/>
      <xsl:message>
         <xsl:text>Generated ZIP release file </xsl:text>
         <xsl:value-of select="pp:display-filename($release)"/>
      </xsl:message>
   </xsl:template>

   <!--
       The default implem just returns itself; to be overriden in a
       specific project, if needed.
   -->
   <xsl:template match="zip:file" mode="pp:modify-release">
      <xsl:sequence select="."/>
   </xsl:template>

</xsl:stylesheet>
